--
-- siloSell
-- 
-- 
--
-- upsideDown 16.12.2013
-- conversion to LS15: 1.11.2014

siloSell = {};
addModEventListener(siloSell);
function siloSell.prerequisitesPresent(specializations)
    return true;
end;

function siloSell:loadMap(name)
	siloSell.currentFillType = Fillable.FILLTYPE_WHEAT;
	siloSell.transportFee = 1000*g_currentMission.missionStats.difficulty; 
	siloSell.truckLoad = 45000;
	siloSell.clientRequest = false;
	siloSell.clientFillType = Fillable.FILLTYPE_UNKNOWN;
	
	-- search for "liquitmanurestorage" : 	
	-- for k,object in pairs(g_currentMission.onCreateLoadedObjects) do
		-- if object.DoReFill ~= nil then
			-- object.update = LiquidManureFillTrigger.update;
		-- end;
	-- end;
	
	
	
	-- local ocf = onCreateUtil.onCreateFunctions["liquitmanurestorageOnCreate"];
	-- if ocf ~= nil then
		-- print("HIT!")
	-- else
		-- print("fail... :(")
	-- end;
end;

function siloSell:deleteMap()
end


function siloSell:mouseEvent(posX, posY, isDown, isUp, button)
end;

function siloSell:keyEvent(unicode, sym, modifier, isDown)
end;


function siloSell:update(dt)
	if g_currentMission:getIsClient() then
		if g_gui.currentGui == nil then
			if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
				if g_currentMission.controlledVehicle == nil then
					if not InputBinding.isPressed(InputBinding.siloVerkauf_mod) then
						g_currentMission:addHelpButtonText(g_i18n:getText("siloVerkauf3"), InputBinding.siloVerkauf_mod);
					end;
					if InputBinding.isPressed(InputBinding.siloVerkauf_mod) or siloSell.clientRequest then
						if siloSell.currentFillType ~= Fillable.FILLTYPE_UNKNOWN and InputBinding.isPressed(InputBinding.siloVerkauf_mod) then
							g_currentMission:setFillTypeOverlayFillType(siloSell.currentFillType);
						end;
						if InputBinding.isPressed(InputBinding.siloVerkauf_mod) then
							g_currentMission:addHelpButtonText(g_i18n:getText("siloVerkauf2"), InputBinding.siloVerkauf_2);
						end;
						
						if g_currentMission.missionStats.farmSiloAmounts[siloSell.currentFillType] == 0 then
							siloSell.currentFillType = Fillable.FILLTYPE_UNKNOWN;
						end;
						
						if InputBinding.hasEvent(InputBinding.siloVerkauf_2) then
							local cnt = 0;
							
							siloSell.currentFillType = siloSell.currentFillType + 1;
							if siloSell.currentFillType > 64 then
								siloSell.currentFillType = 1;
							end;
							
							while Utils.getNoNil(g_currentMission.missionStats.farmSiloAmounts[siloSell.currentFillType],0) == 0 do
								siloSell.currentFillType = siloSell.currentFillType + 1;
								if siloSell.currentFillType > 64 then
									siloSell.currentFillType = 1;
								end;
								cnt = cnt+1;							
								if cnt > 65 then --silos are all empty
									siloSell.currentFillType = Fillable.FILLTYPE_UNKNOWN;
									break;
								end;
							end;					
						end;
					
						if siloSell.currentFillType ~= Fillable.FILLTYPE_UNKNOWN or (siloSell.clientRequest and siloSell.clientFillType ~= Fillable.FILLTYPE_UNKNOWN) then
							if InputBinding.isPressed(InputBinding.siloVerkauf_mod) then
								g_currentMission:addHelpButtonText(g_i18n:getText("siloVerkauf"), InputBinding.siloVerkauf_1);
							end;
							local fillType = siloSell.currentFillType;--Fillable.FILLTYPE_WHEAT;
							if siloSell.clientRequest or InputBinding.hasEvent(InputBinding.siloVerkauf_1) then
								if siloSell.clientRequest then
									fillType = siloSell.clientFillType;
									siloSell.clientRequest = false;
								end;
								local Amount = g_currentMission:getSiloAmount(fillType);							
								
								local delta = math.min(siloSell.truckLoad,Amount);
								
								local desc = Fillable.fillTypeIndexToDesc[fillType];
								desc.totalAmount = desc.totalAmount - delta;
					
								local priceFactor = 0;
								for _,tip in pairs(g_currentMission.tipTriggers) do
									local testFactor = Utils.getNoNil(tip.priceMultipliers[fillType],0);
									
									local greatDemand = g_currentMission.economyManager:getCurrentGreatDemand(tip.stationName, fillType);
									local greatDemandMultiplier = 1;
									if greatDemand ~= nil then
										testFactor = testFactor*greatDemand.demandMultiplier;
									end;
									priceFactor = math.max(priceFactor,testFactor);							
								end;
								
								local difficultyMultiplier = math.max(2 * (3 - g_currentMission.missionStats.difficulty), 1);
								local money = Fillable.fillTypeIndexToDesc[fillType].pricePerLiter * priceFactor * difficultyMultiplier * delta;
								if g_currentMission:getIsServer() then
									g_currentMission:setSiloAmount(fillType,Amount-delta);
									g_currentMission:addSharedMoney(money, "harvestIncome");
									g_currentMission:addSharedMoney(-siloSell.transportFee, "wagePayment");						
								else
									g_client:getServerConnection():sendEvent(siloSellEvent:new(fillType));
								end;
							end;
						end;
					end;	
				end;
			end;
		end;
	end
end


function siloSell:draw()   
end;

siloSellEvent = {};
siloSellEvent_mt = Class(siloSellEvent, Event);

InitEventClass(siloSellEvent, "siloSellEvent");

function siloSellEvent:emptyNew()
    local self = Event:new(siloSellEvent_mt);
    return self;
end;

function siloSellEvent:new(fillType,fillLevel,money)
    local self = siloSellEvent:emptyNew()
    self.fillType = fillType;
    return self;
end;

function siloSellEvent:readStream(streamId, connection)   
    self.fillType = streamReadInt8(streamId);
    self:run(connection);
end;

function siloSellEvent:writeStream(streamId, connection)    
    streamWriteInt8(streamId, self.fillType);
end;

function siloSellEvent:run(connection)
	siloSell.clientFillType = self.fillType;
	siloSell.clientRequest = true;
end;

--[[
local oldLMFT_update = LiquidManureFillTrigger.update;
function LiquidManureFillTrigger:update(dt)
	
	oldLMFT_update(self,dt)
	
	if g_currentMission:getIsClient() then
		if g_gui.currentGui == nil then
			if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
				if (g_currentMission.controlPlayer and self.playerInRange) then --only for player on foot
					if not InputBinding.isPressed(InputBinding.LM_mod) then
						g_currentMission:addHelpButtonText(g_i18n:getText("LM_mod"), InputBinding.LM_mod);
					end;
					
					if InputBinding.isPressed(InputBinding.LM_mod) or false then
						if InputBinding.isPressed(InputBinding.LM_mod) then
							if self.fillLevel < self.capacity then
								g_currentMission:addHelpButtonText(g_i18n:getText("LM_buy"), InputBinding.LM_buy);
							end;
						
							if self.fillLevel > 0 then
								g_currentMission:addHelpButtonText(g_i18n:getText("LM_sell"), InputBinding.LM_sell);
							end;
						end;
						
						if InputBinding.hasEvent(InputBinding.LM_buy) then
							if self.fillLevel < self.capacity then
								local delta = math.min(28000,self.capacity-self.fillLevel);
								--print("buy: "..tostring(delta))
								self:setFillLevel(self.fillLevel+delta, false);
								if delta > 0 then
									local transportFee = 1000*g_currentMission.missionStats.difficulty; 
									g_currentMission:addSharedMoney(-transportFee, "wagePayment");	
								end;
							end;						
						end;
						
						if InputBinding.hasEvent(InputBinding.LM_sell) then
							if self.fillLevel > 500 then
								local delta = math.min(28000,self.capacity);
								--print("buy: "..tostring(delta))
								self:setFillLevel(self.fillLevel-delta, false);
								if delta > 0 then
									local transportFee = 1000*g_currentMission.missionStats.difficulty; 
									g_currentMission:addSharedMoney(-transportFee, "wagePayment");	
								end;
							end;						
						end;
						
					
					end;
					
					--if self.fillLevel < self.capacity then					
						
					--end;					
				end;
			end;
		end;
	end;
		
end;

]]
